select
  an.numero as "N animal"
  , an.regassocraca as "Registro"
  , an.nome as "Nome"
  , an.dtnascimento as "Data_de_nascimento"
  , idade.anos || ' ano(s) ' || idade.meses || ' ms(s) ' || idade.dias || ' dia(s)' as "IDADE"
  , (case an.cdcategoria when 6 then 'Novilha' when 7 then 'Vaca' else null end) as "Categoria_atual"
  , coalesce(pai.nome, pai.numero) as "Nome pai"
  , coalesce(mae.nome, mae.numero) as "Nome me"
  , up.data as "Dt. lt. parto"
  , (current_date - up.data) as "Dias ps parto"
  , (select count(*) from programacaoiatfassociacao where cdanimal = an.cdanimal
    and cdprogramacaoiatf in (select cdprogramacaoiatf from programacaoiatf where dtimplante > coalesce(up.data, '1900-01-01'))) as "N Protocolo hormonal no ciclo atual"
  , pg.dtimplante as "Data do ultimo protocolo hormonal"
  , (select count(*) from reproducao where cdanimal = an.cdanimal
    and data > coalesce(up.data, '1900-01-01')
    and cdtiporeproducao in (1,2,3)) as "Ten. concep."
  , (case catpro.cdcategoria
    when 3 then 'Seca'
    when 4 then 'Em Lactao'
  else null end) as "Sit. pro."
  , (case catrep.cdcategoria
    when 1 then 'Insem./Cob.'
    when 2 then 'Implant.'
    when 3 then 'Gestante'
    when 4 then 'Vazia'
  else catrep.cdcategoria end) as "Sit. rep."
  , (current_date - uia.data) as "Dias IA/TE/cob."
  , (current_date - usec.dtfim) as "Dias lt. sec."
  , s.nome as "Nome setor at."
from
  animal an
  left join sp_idadeanimal('', 'WHERE CDANIMAL = ' || an.cdanimal) idade on 1=1
  left join animal pai on pai.cdanimal = an.cdpai
  left join animal mae on mae.cdanimal = an.cdmae
  left join reproducao up on up.cdreproducao =
    (select first 1 re.cdreproducao
    from reproducao re
    where re.cdanimal = an.cdanimal
      and re.cdtiporeproducao = 7
    order by re.data desc)
  left join reproducao uia on uia.cdreproducao =
    (select first 1 re.cdreproducao from reproducao re where re.cdanimal = an.cdanimal
      and re.cdtiporeproducao in (1,2,3)
      and re.data > coalesce(up.data, '1900-01-01')
    order by re.data desc)
  left join lactacao usec on usec.cdlactacao =
    (select first 1 rel.cdlactacao from lactacao rel where rel.cdanimal = an.cdanimal
      and rel.dtfim is not null
    order by rel.dtfim desc)
  left join programacaoiatf pg on pg.cdprogramacaoiatf =
    (select first 1 re2.cdprogramacaoiatf from programacaoiatf re2
    where re2.cdprogramacaoiatf in (select cdprogramacaoiatf from programacaoiatfassociacao where cdanimal = an.cdanimal)
      and re2.dtimplante > coalesce(up.data, '1900-01-01')
    order by re2.dtimplante desc)
  join categoria catrep on catrep.cdcategoria =
    (select sp.creprodutiva from sp_categoriaanimal(current_date, 'cdanimal = ' || an.cdanimal) sp)
  left join categoria catpro on catpro.cdcategoria =
    (select sp.cprodutiva from sp_categoriaanimal(current_date, 'cdanimal = ' || an.cdanimal) sp)
  join setor s on s.cdsetor = an.cdsetor
where
  an.tipoanimal = 'A'
  and an.animalrebanho = 1
  and an.sexo = 'F'
  and an.dtbaixa is null

